 program

  map
  end

Check1        Byte(1)
Check2        Byte
Check3        Byte

  Include('JSROCHK.INC')

RO JSReadonlyCheck !Class instance of the readonly check class

Window WINDOW('Readonly Checkboxes'),AT(,,243,76),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
       BUTTON('Push me'),AT(5,5,45,14),USE(?Button1)
       CHECK('&Check 1 (Readonly)'),AT(5,23),USE(Check1)
       CHECK('Check 2 (Not Readonly and also sets the value of Check1 to Check2)'),AT(5,33),USE(Check2)
       CHECK('Check 3'),AT(5,44),USE(Check3)
       BUTTON('&Toggle "Check 3" Readonly Status'),AT(3,60,136,14),USE(?ToggleButton)
       BUTTON('&Close'),AT(196,60,45,14),USE(?CloseButton),STD(std:close)
     END

  Code

  Open(Window)
  RO.AddItem(?Check1)             !Set ?Check1 to Readonly
  Accept
    RO.TakeEvent()                !Allows the ReadOnlyCheck class to do it's thing
    Case Accepted()
    of ?Check2
      RO.SetValue(?Check1,Check2) !Set the value of the checkbox and it's contents
      Display(?Check1)
    of ?Button1
      Message('This button doesn''t do anything :-)','Thank You!', ICON:Exclamation)
    of ?ToggleButton
      If RO.Fetch(?Check3)        !How to tell if the checkbox is under control of the class
        RO.AddItem(?Check3)       !Set it to Readonly
        ?Check3{PROP:Text} = 'Check 3 (Readonly)'
      else
        RO.RemoveItem(?Check3)    !Remove the readonly
        ?Check3{PROP:Text} = 'Check 3'
      end
    end
  end
