 member

!-----------------------------------------------------------------------------!
! J&S ReadOnly Check Class .9000
! Class Source
! Copyright (c) 2001 by J&S Software Co. (jeff@jssoftware.com)
!-----------------------------------------------------------------------------!
 
  map
  end
  
FEQQ          Queue,Type
FEQ             Long
Value           ANY
              end
  
  Include('JSROChk.inc'),ONCE
  
!========================================================================================================================================================
JSReadonlyCheck.AddItem    Procedure(Long FEQ)
!========================================================================================================================================================

  Code

  If FEQ{PROP:Type} = Create:Check
    If Self.Fetch(FEQ)
      Clear(Self.FEQQ)
      Self.FEQQ.FEQ = FEQ
      Add(Self.FEQQ)
    end  
    Self.FEQQ.Value = Contents(FEQ)
    Put(Self.FEQQ)
  end

!========================================================================================================================================================
JSReadonlyCheck.Construct  Procedure
!========================================================================================================================================================

  Code

  Self.FEQQ &= NEW(FEQQ)
  Free(Self.FEQQ)
  Clear(Self.FEQQ)

!========================================================================================================================================================
JSReadonlyCheck.Destruct  Procedure
!========================================================================================================================================================

   Code

  Loop
    Get(Self.FEQQ,1)
    If ErrorCode() then break.
    Self.FEQQ.Value &= NULL
    Delete(Self.FEQQ)
  end
  Dispose(Self.FEQQ)

!========================================================================================================================================================
JSReadOnlyCheck.Fetch      Procedure(Long FEQ)
!========================================================================================================================================================

  Code

    Self.FEQQ.FEQ = FEQ
    Get(Self.FEQQ,Self.FEQQ.FEQ)
    Return ErrorCode()


!========================================================================================================================================================
JSReadonlyCheck.RemoveItem        Procedure(Long FEQ)
!========================================================================================================================================================

  Code
  
  If NOT Self.Fetch(FEQ)
    Self.FEQQ.Value &= NULL
    Delete(Self.FEQQ)
  end

!========================================================================================================================================================
JSReadonlyCheck.SetValue   Procedure(Long FEQ,? Value)
!========================================================================================================================================================

  Code

  If NOT Self.Fetch(FEQ)
    Self.FEQQ.Value = Value
    Put(Self.FEQQ)
    Change(FEQ,Self.FEQQ.Value)
  end

!========================================================================================================================================================
JSReadonlyCheck.TakeEvent  Procedure
!========================================================================================================================================================

  Code

  If Self.Fetch(Field()) then return .
  Case Event()
  of Event:Accepted
    Change(?,Self.FEQQ.Value)
  end
